<?php
$props["login"] = "0";
global $ADEI_ROOTDIR;
require_once($ADEI_ROOTDIR."/adei_ui.php");
class VGReader extends READER{
 var $settings;
 var $msakInfoArray;
 var $login;

 function __construct(&$props){
    //print_r($props);
    global $ADEI_ROOTDIR;
    parent::__construct($props);
    $pathToConfigFile = $ADEI_ROOTDIR."/config.xml";
    if(!file_exists($pathToConfigFile)){
        die("Configurtion file does not exists: ".$pathToConfigFile);
    }
    $this->settings = simplexml_load_file($pathToConfigFile);
    if(!is_object($this->settings)){
        die("Error while loading configuration file: ".$pathToConfigFile);
    }
    $this->validateUserInProps();
 }
 function getNameOfServer($serverId = FALSE, $flags = 0){
    if(!$serverId){
	return "unnamed";
    }
    $req = new REQUEST($_GET);
    $list = $req->GetServerList($flags);
    if(array_key_exists($serverId, $list)){
	return $list[$serverId]["name"];
    }else{
	return "unnamed";
    }
 }
 function getNameOfDB($serverId = FALSE, $dbId = FALSE, $flags = 0){
    if(!($serverId&&$dbId)){
	return "unnamed";
    }
    $a = array ('db_server' => $serverId);
    $srvreq = new SERVERRequest($a);
    $dbList = $srvreq->GetDatabaseList($flags);
    foreach($dbList as $db){
	if($dbId == $db["name"]){
	    return $db["db_name_name"];
	}
    }
    return "unnamed";
 }
 function getNameOfGroup($serverId = FALSE, $dbId = FALSE, $groupId = FALSE, $flags = 0){
    if(!($serverId&&$dbId&&$groupId)){
	return "unnamed";
    }
    $a = array(
	'db_server' => $serverId,
	'db_name' => $dbId,
    );
    $groupSourceReq = new SOURCERequest($a);
    $groupList = $groupSourceReq->GetGroupList($flags);
    reset($groupList);
    foreach($groupList as $group){
	if($groupId == $group["gid"]){
	    return $group["name"];
	}
    }
    return "unnamed";
 }
 function getNameOfChannel($serverId = FALSE, $dbId = FALSE, $groupId = FALSE, $channelId = FALSE, $flags = 0){
    if(!($serverId&&$dbId&&$groupId&&$channelId)){
	return "unnamed";
    }
    $a = array(
	'db_server' => $serverId,
	'db_name' => $dbId,
	'db_group' => $groupId
    );
    $dbreq = new GROUPRequest($a);
    $itemsList = $dbreq->GetItemList($flags);
    $listArray = array();
    foreach($itemsList as $item){
	if($channelId == $item["id"]){
	    return $item["name"];
	}
    }
    return "unnamed";
 }


 function serverExists($serverId = FALSE, $flags = 0){
    if(!$serverId){
	return false;
    }
    $req = new REQUEST($_GET);
    $list = $req->GetServerList($flags);
    return array_key_exists($serverId, $list);
 }
 function dBExists($serverId = FALSE, $dbId = FALSE, $flags = 0){
    if(!($serverId&&$dbId)){
	return false;
    }
    $a = array ('db_server' => $serverId);
    $srvreq = new SERVERRequest($a);
    $dbList = $srvreq->GetDatabaseList($flags);
    return array_key_exists($dbId, $dbList);
 }
 function groupExists($serverId = FALSE, $dbId = FALSE, $groupId = FALSE, $flags = 0){
    if(!($serverId&&$dbId&&$groupId)){
	return false;
    }
    $a = array(
	'db_server' => $serverId,
	'db_name' => $dbId,
    );
    $groupSourceReq = new SOURCERequest($a);
    $groupList = $groupSourceReq->GetGroupList($flags);
    reset($groupList);
    return array_key_exists($groupId, $groupList);
 }
 function channelExists($serverId = FALSE, $dbId = FALSE, $groupId = FALSE, $channelId = FALSE, $flags = 0){
    if(!($serverId&&$dbId&&$groupId&&$channelId)){
	return false;
    }
    $a = array(
	'db_server' => $serverId,
	'db_name' => $dbId,
	'db_group' => $groupId
    );
    $dbreq = new GROUPRequest($a);
    $itemsList = $dbreq->GetItemList($flags);
    return array_key_exists($channelId, $itemsList);
 }

 function idToNames($serverId, $dbId, $groupId){
    $serverName = $this->getNameOfServer($serverId);
    $dbName = $this->getNameOfDB($serverId, $dbId);
    $groupName = $this->getNameOfGroup($serverId, $dbId, $groupId);
    return $serverName." - ".$dbName." - ".$groupName;
 }
 function GetGroupInfo(LOGGROUP $grp = NULL, $flags = 0){
    $groups = array();
    $maskManager = new MaskManagerClass($this->settings);
    $maskArray = $maskManager->getMaskStructureAsArray($this->dbname, $this->login);
    //echo "MaskArray: ".$this->dbname." ";
    //print_r($maskArray);
    $groups = array();
    while(list($prefix, $info) = each($maskArray["postfixes"])){
	if($grp && ($prefix != $grp->gid)){
	    continue;
	}
	$gid = $info["path"];
	$groups[$gid]["gid"] = $prefix;
	//$groups[$gid]["name"] = $this->idToNames($info["pathArray"], $info["pathArray"][1], $info["pathArray"][2]);
	
	$groups[$gid]["name"] = $this->idToNames($info["pathArray"][0], $info["pathArray"][1], $info["pathArray"][2]);
	$sngArray = array(
	    "db_server" => $info["pathArray"][0],
	    "db_name" => $info["pathArray"][1],
	    "db_group" => $info["pathArray"][2]
	);
	$req = new GROUPRequest($sngArray);
	if($flags&REQUEST::NEED_INFO){
	    $rdr = $req->CreateReader();
	    $myGrp = $this->CreateGroup($sngArray);
	    $grpInfo = $rdr->GetGroupInfo($myGrp, $flags&~REQUEST::NEED_ITEMINFO);
	    $groups[$gid] = $groInfo;
	    if(!($flags&REQUEST::NEED_ITEMINFO)){
		$groups[$gid]['items'] = $this->GetItemList();
	    }
	}
    }
    return $grp?$groups[$grp->gid]:$groups;
 }
 function GetItemList(LOGGROUP $grp = NULL, MASK $mask = NULL, $flags = 0){
    $grp = $this->CheckGroup($grp);
    $groups = array();
    $gIDArray = split("__", $grp->gid);
    $maskManager = new MaskManagerClass($this->settings);
    $maskArray = $maskManager->getMaskStructureAsArray($this->dbname, $this->login);
    $axisManager = new AxisManagerClass($this->settings);
    $axisArray = $axisManager->getAxisOfUser($this->login);
    $axisArrayObject = array();
    while(list($axisId, $value) = each($axisArray)){
	$axisProps = array(
	    "axis" => $value["ID"],
	    "axis_name" => $value["Name"],
	    "axis_units" => $value["Unit"],
	    "axis_mode" => $value["Log"]?(GRAPHAxis::MODE_LOGARITHMIC):(GRAPHAxis::MODE_STANDARD)
	);
	$axisArrayObject[$axisId] = new GRAPHAxis($axisProps);
    }
    // get names of available ids
    $sngArray = array(
        'db_server' => $gIDArray[0],
        'db_name' => $gIDArray[1],
        'db_group' => $gIDArray[2]
    );

    $fullItemsArray = array();
    $dbreq = new GROUPRequest($sngArray);
    $itemsList = $dbreq->GetItemList();
    foreach($itemsList as $item){
	$offset = array_search($item["id"], $maskArray["postfixes"][$grp->gid]["itemIds"]);
	if($offset !== FALSE){
	    $pathArray = $maskArray["postfixes"][$grp->gid]["pathArray"];
	    if(!($this->serverExists($pathArray[0], $flags = 0)&&$this->dBExists($pathArray[0], $pathArray[1], $flags = 0)&&$this->groupExists($pathArray[0], $pathArray[1], $pathArray[2], $flags = 0))){
		// problems with virtual group, something does not exists 
		//var_dump($this->serverExists($info["pathArray"][0])&&$this->dBExists($info["pathArray"][0], $info["pathArray"][1])&&$this->groupExists($info["pathArray"][0], $info["pathArray"][1], $info["pathArray"][2]));
		//echo $info["pathArray"][0]." ".$info["pathArray"][1]." ".$info["pathArray"][2];
		continue;
	    }
	    array_push(
		$fullItemsArray,
		array(
		    "id" => $item["id"],
		    "name" => $item["name"],
		    "axis" => $axisArrayObject[$maskArray["postfixes"][$grp->gid]["axisIds"][$offset]]
		)
	    );
	}
    }
    if($mask->ids){
	if(!sizeof($mask->ids)){
	    return array();
	}else{
	    reset($fullItemsArray);
	    $items = array();
	    for($i=0; $i<sizeof($fullItemsArray); $i++){
		if(array_key_exists($i, $mask->ids)){
		    array_push($items, $fullItemsArray[$i]);
		}
	    }
	}
    }else{
	$items = $fullItemsArray;
    }
    return $items;
 }

 function GetRawData(LOGGROUP $grp = NULL, $from = 0, $to = 0, DATAFilter $filter = NULL, &$filter_data = NULL, $flags = 0) {
    $grp = $this->CheckGroup($grp);
    $gID = $grp->gid;
    $maskManager = new MaskManagerClass($this->settings);
    $maskArray = $maskManager->getMaskStructureAsArray($this->dbname, $this->login);
    $realGroup = $maskArray["postfixes"][$grp->gid];
    $sngArray = $this->req->props;
    $sngArray["db_server"] = $realGroup["pathArray"][0];
    $sngArray["db_name"] = $realGroup["pathArray"][1];
    $sngArray["db_group"] = $realGroup["pathArray"][2];
    $req = new GROUPRequest($sngArray);
    $rdr = $req->CreateReader();
    $myGrp = $this->CreateGroup($sngArray);
    return $rdr->GetRawData($myGrp, $from, $to, $filter, $filter_data);
 }
 function HaveData(LOGGROUP $grp = NULL, $from = 0, $to = 0, $flags = 0){
    $grp = $this->CheckGroup($grp, $flags);
    $gID = $grp->gid;
    $maskManager = new MaskManagerClass($this->settings);
    $maskArray = $maskManager->getMaskStructureAsArray($this->dbname, $this->login);
    $realGroup = $maskArray["postfixes"][$grp->gid];
    $sngArray = $this->req->props;
    $sngArray["db_server"] = $realGroup["pathArray"][0];
    $sngArray["db_name"] = $realGroup["pathArray"][1];
    $sngArray["db_group"] = $realGroup["pathArray"][2];
    $req = new GROUPRequest($sngArray, $flags);
    $rdr = $req->CreateReader();
    $myGrp = $this->CreateGroup($sngArray, $flags);

    return $rdr->HaveData($myGrp, $from, $to, $flags = 0);
 }
 function GetDatabaseList($flags = 0){
    $maskManager = new MaskManagerClass($this->settings);
    $userMasks = $maskManager->getListOfUserMasks($this->login);
    $maskArray = $maskManager->getMaskStructureAsArray($this->dbname, $this->login);
    $retArray = array();
    foreach($userMasks as $maskName){
	    $maskExists = true;
	    $maskArray = $maskManager->getMaskStructureAsArray($maskName, $this->login);
	    while(list($postfix, $value) = each($maskArray["postfixes"])){
		$pathArray = $value["pathArray"];
		if(!($this->serverExists($pathArray[0], $flags)&&$this->dBExists($pathArray[0], $pathArray[1], $flags)&&$this->groupExists($pathArray[0], $pathArray[1], $pathArray[2], $flags))){
		    // problems with virtual group, something does not exists 
		    //var_dump($this->serverExists($info["pathArray"][0])&&$this->dBExists($info["pathArray"][0], $info["pathArray"][1])&&$this->groupExists($info["pathArray"][0], $info["pathArray"][1], $info["pathArray"][2]));
		    //echo $info["pathArray"][0]." ".$info["pathArray"][1]." ".$info["pathArray"][2];
		    $maskExists = false;
		}
	    }
	    if($maskExists){
		$retArray[$maskName] = array(
		    "name" => $maskName
		);
	    }
    }
    return $retArray;
 }

 function GetRealGroupInfo(LOGGROUP $grp = NULL, $flags = 0) {
    $grp = $this->CheckGroup($grp);

    $gID = $grp->gid;
    $maskManager = new MaskManagerClass($this->settings);
    $maskArray = $maskManager->getMaskStructureAsArray($this->dbname, $this->login);
    $realGroup = $maskArray["postfixes"][$grp->gid];

    $sngArray = $this->req->props;
    $sngArray["db_server"] = $realGroup["pathArray"][0];
    $sngArray["db_name"] = $realGroup["pathArray"][1];
    $sngArray["db_group"] = $realGroup["pathArray"][2];

    return $sngArray;
 }
 function CreateCache(LOGGROUP $grp = NULL, $flags = 0) {
    $info = $this->GetRealGroupInfo($grp);
    $greq = new GROUPRequest($info);
    return new CACHE($greq, $rdr = NULL, $flags);
 }
 function validateUserInProps(){
//    if(!isset($this->req->login)){
	$this->login = "0";
//    }
 }
}
?>