<?php
class AxisManagerClass{
    var $db;
    var $settings;
    var $ack;
    var $tempValues;

    function AxisManagerClass($settingsObj){
	$this->settings = $settingsObj;
	$this->db = new userManagerDatabaseClass($this->settings->Databases);
	$this->manageTables = new manageTablesClass($this->db);
	$this->manageTables->checkAndCreateTablesFromXmlObj($this->settings->MasksModule->DatabaseTables);
	$this->tempValues["UserID"] = 0;
    }
    function updateAxis($json){
	$jsonObj = json_decode($json);
	$existingAxis = $this->getAxisOfUser($this->tempValues["UserID"]);
	$valuesArray = array();
	$queries = array();
	$numberOfElementsInJson = 0;
	foreach($jsonObj->Axis as $axis){
	    $numberOfElementsInJson++;
	    if($axis->Log){
		$log = "true";
	    }else{
		$log = "false";
	    }
	    if(empty($axis->RangeBegin)){
		$rangeBegin = "NULL";
	    }else{
		$rangeBegin = (float) $axis->RangeBegin;
	    }
	    if(empty($axis->RangeEnd)){
		$rangeEnd = "NULL";
	    }else{
		$rangeEnd = (float) $axis->RangeEnd;
	    }
	    if(!array_key_exists((String) $axis->ID, $existingAxis)){
		array_push(
		    $queries,
		    "INSERT INTO ".$this->settings->MasksModule->DatabaseTables->AxisTable->Name." ("
			."`".$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->UserID."`, "
			."`".$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->AXID."`, "
			."`".$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->AxisName."`, "
			."`".$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->Units."`, "
			."`".$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->Log."`, "
			."`".$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->Color."`,"
			."`".$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->RangeBegin."`, "
			."`".$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->RangeEnd."`"
		    .") VALUES "
		    ."('".$this->tempValues["UserID"]."', '".$axis->ID."', '".$axis->Name."', '".$axis->Unit."', ".$log.", '".$axis->Color."', ".$rangeBegin.", ".$rangeEnd.")"
		    .";"
		);
		continue;
	    }
	    $oneRowArrray = array(
		"ID" => (String) $axis->ID,
		"Name" => (String) $axis->Name,
		"Unit" => (String) $axis->Unit,
		"Log" => $axis->Log,
		"Color" => (String) $axis->Color,
		"RangeBegin" => $axis->RangeBegin,
		"RangeEnd" => $axis->RangeEnd
	    );
	    if( $existingAxis[$axis->ID] != $oneRowArrray ){
		array_push(
		    $queries,
		    "UPDATE ".$this->settings->MasksModule->DatabaseTables->AxisTable->Name." SET "
			.$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->AxisName." = '".$axis->Name."', "
			.$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->Units." = '".$axis->Unit."', "
			.$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->Log." = ".$log.", "
			.$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->Color." = '".$axis->Color."',"
			.$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->RangeBegin." = ".$rangeBegin.","
			.$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->RangeEnd." = ".$rangeEnd
		    ." WHERE "
			.$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->UserID." = '".$this->tempValues["UserID"]."'"
			." AND "
			.$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->AXID." = '".$axis->ID."'"
			.";"
		);
	    }
	}
	$maskNamesWithUsedAxis = array();
	$usedAxis = array();
	for($i=$numberOfElementsInJson; $i<sizeof($existingAxis); $i++){
	    $maskNames = $this->checkIfAxisExists($i);
	    if($maskNames != -1){
		$maskNamesWithUsedAxis = array_merge($maskNamesWithUsedAxis, $maskNames);
		array_push($usedAxis, $existingAxis["Name"]);
	    }else{
		array_push(
		    $queries,
		    "DELETE FROM ".$this->settings->MasksModule->DatabaseTables->AxisTable->Name." WHERE ".$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->AXID." = ".$i.";"
		);
	    }
	}
	array_unique($maskNamesWithUsedAxis);
	array_unique($usedAxis);
	if(sizeof($maskNamesWithUsedAxis) != 0){
	    $this->ack = "Axis: ".implode(", ", $usedAxis)." because they are used in following masks: ".implode(", ", $maskNamesWithUsedAxis);
	}
	foreach($queries as $sql){
	    $this->db->sql_getRows($sql);
	    echo $this->db->error;
	    echo $sql;
	}
	return;
    }
    function getAxisOfUserAsJson(){
	$existingAxis = $this->getAxisOfUser($this->tempValues["UserID"]);
	$retArray = array("Axis" => array());
	reset($existingAxis);
	foreach($existingAxis as $axis){
	    array_push($retArray["Axis"], $axis);
	}
	$retArray["total"] = sizeof($retArray["Axis"]);
	$this->ack = json_encode($retArray);
	return;
    }
    function getAxisOfUserAsArray(){
	$existingAxis = $this->getAxisOfUser($this->tempValues["UserID"]);
	$retArray = array();
	reset($existingAxis);
	foreach($existingAxis as $axis){
	    array_push($retArray, $axis);
	}
	return $retArray;
    }
    function getAxisOfUser($userId){
	$retArray = array();
	$sql = "SELECT * FROM ".$this->settings->MasksModule->DatabaseTables->AxisTable->Name." WHERE ".$this->settings->MasksModule->DatabaseTables->AxisTable->Columns->UserID." = '".$userId."';";
	$this->db->sql_getRows($sql);
	while($raw = mysql_fetch_assoc($this->db->mysql["query_result"])){
		$id = $raw[(String) $this->settings->MasksModule->DatabaseTables->AxisTable->Columns->AXID];
		$retArray[$id] = array(
		    "ID" => $raw[(String) $this->settings->MasksModule->DatabaseTables->AxisTable->Columns->AXID],
		    "Name" => $raw[(String) $this->settings->MasksModule->DatabaseTables->AxisTable->Columns->AxisName],
		    "Unit" => $raw[(String) $this->settings->MasksModule->DatabaseTables->AxisTable->Columns->Units],
		    "Log" => (boolean) $raw[(String) $this->settings->MasksModule->DatabaseTables->AxisTable->Columns->Log],
		    "Color" => $raw[(String) $this->settings->MasksModule->DatabaseTables->AxisTable->Columns->Color],
		    "RangeBegin" => $raw[(String) $this->settings->MasksModule->DatabaseTables->AxisTable->Columns->RangeBegin],// == "null"? "": $raw[(String) $this->settings->MasksModule->DatabaseTables->AxisTable->Columns->RangeBegin],
		    "RangeEnd" => $raw[(String) $this->settings->MasksModule->DatabaseTables->AxisTable->Columns->RangeEnd]// == "null"? "": $raw[(String) $this->settings->MasksModule->DatabaseTables->AxisTable->Columns->RangeEnd]
		);
	}
	return $retArray;
    }
    function checkIfAxisExists($axisId){
	$maskNames = array();
	$sql = "SELECT ".$this->settings->MasksModule->DatabaseTables->VgElements->Columns->MaskName." FROM ".$this->settings->MasksModule->DatabaseTables->VgElements->Name." WHERE FIND_IN_SET(".$axisId.", ".$this->settings->MasksModule->DatabaseTables->VgElements->Columns->ItemAxis.");";
	$resultArray = $this->db->sql_getRows($sql);
	if(is_array($resultArray)){
	    return -1;
	}else{
	    while($raw = mysql_fetch_assoc($this->db->mysql["query_result"])){
		array_push($maskNames, $raw[$this->settings->MasksModule->DatabaseTables->VgElements->Columns->MaskName]);
	    }
	    return $maskNames;
	}
    }
    function getAck(){
	return $this->ack;
    }
}
?>