<?php
class manageTablesClass{
    var $db;
    var $tableDumpsVector;

    function manageTablesClass($dbObj){
	$this->initializeTableDumpsVector();
	$this->db = $dbObj;
    }
    function checkAndCreateTablesFromXmlObj($simpleXmlObj){
	foreach($simpleXmlObj[0] as $table){
	    $this->checkIfTableExistsAndCreate((String) $table->Name, (String) $table->DumpName);
	}
    }
    function checkIfTableExistsAndCreate($tableName, $dumpName){
	if(array_key_exists($dumpName, $this->tableDumpsVector)){
	    if(!$this->db->checkIfTableExists($tableName) && array_key_exists("Create", $this->tableDumpsVector[$dumpName])){
		$this->db->sql_query(
			str_replace(
			    '%%TABLE_NAME%%',
			    $tableName,
			    $this->tableDumpsVector[$dumpName]["Create"]
			)
		);
		if(array_key_exists("Insert", $this->tableDumpsVector[$dumpName])){
		    $this->db->sql_query(
			str_replace(
			    '%%TABLE_NAME%%',
			    $tableName,
			    $this->tableDumpsVector[$dumpName]["Insert"]
			)
		    );
		}
	    }
	}
    }
    function initializeTableDumpsVector(){
	$this->tableDumpsVector["AccountsDump"]["Create"] = "
	    CREATE TABLE `%%TABLE_NAME%%` (
		`Name` varchar(200) default NULL,
		`Surname` varchar(200) default NULL,
		`Institution` varchar(200) default NULL,
		`Affiliation` varchar(200) default NULL,
		`Address1` varchar(200) default NULL,
		`Address2` varchar(200) default NULL,
		`City` varchar(200) default NULL,
		`StateProvince` varchar(200) default NULL,
		`ZipPost` varchar(200) default NULL,
		`Country` varchar(200) default NULL,
		`Phone` varchar(200) default NULL,
		`Fax` varchar(200) default NULL,
		`EMail` varchar(200) default NULL,
		`Login` varchar(200) default NULL,
		`Password` varchar(200) default NULL,
		`LastLoginDate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
		`availableGlobalGroups` int(11) default NULL
	    ) ENGINE=MyISAM DEFAULT CHARSET=latin1;
	";
	$this->tableDumpsVector["AxisDump"]["Create"] = "
	    CREATE TABLE `%%TABLE_NAME%%` (
		`axid` CHAR(128),
		`userid` CHAR(128),
		`title` CHAR(128),
		`units` CHAR(128),
		`log` TINYINT(1),
		`color` CHAR(10),
		`rangeBegin` float NULL,
		`rangeEnd` float NULL,
		`config` TEXT,
		INDEX iuser (axid)
	    );
	";
	$this->tableDumpsVector["AxisDump"]["Insert"] = "
	    INSERT INTO `%%TABLE_NAME%%` VALUES
		('0','0','Standard Axis','Standard',FALSE,'#ff0011',NULL,NULL,'Config will be here'),
		('1','0','Logarithmic Axis','Logarithmic',TRUE,'#ff0011', NULL,NULL,'Config will be here'),
		('2','0','Temperature Logarithmic Axis','Log K',TRUE,'#ff0011',NULL,NULL,'Config will be here'),
		('3','0','Temperature Normal Axis','K',FALSE,'#ff0011',NULL,NULL,'Config will be here'),
		('4','0','Electric Current Logarithmic Axis','Log A',TRUE,'#ff0011',NULL,NULL,'Config will be here'),
		('5','0','Electric Current Normal Axis','A',TRUE,'#ff0011',NULL,NULL,'Config will be here');
	";
	$this->tableDumpsVector["vGroupsDump"]["Create"] = "
	    CREATE TABLE `%%TABLE_NAME%%` (
		`VGroupID` CHAR(128) NOT NULL PRIMARY KEY,
		`VGroupName` TEXT,
		`userid` CHAR(128) NULL,
		`dateOfCreation` TIMESTAMP,
		`numberOfElements` INT,
		`numberOfGroups` INT,
		`config` TEXT,
		INDEX iuser (userid)
	    );
	";
	$this->tableDumpsVector["vgElementsDump"]["Create"] = "
	    CREATE TABLE `%%TABLE_NAME%%` (
		`VGroupID` CHAR(128) NOT NULL,
		`postfix` CHAR(128) NOT NULL,
		`itemids` TEXT NOT NULL,
		`axisids` TEXT NOT NULL,
		`scaleids` TEXT NULL,
		UNIQUE INDEX (VGroupID, postfix)
	    );
	";
    }
}
?>