<?php
class managerClass{
    var $ack;
    var $settings;

    function managerClass($pathToConfigFile){
	if(!file_exists($pathToConfigFile)){
	    die("Configurtion file does not exists: ".$pathToConfigFile);
	}
	$this->settings = simplexml_load_file($pathToConfigFile);
	if(!is_object($this->settings)){
	    die("Error while loading configuration file: ".$pathToConfigFile);
	}
    }
    function setRequest($get, $post){
        try{
	    switch($_GET['target']){
		case 'servers':
		    $em = new ElementsManagerClass();
		    $em->getList($post);
		    $this->ack = $em->getAck();
		break;
		case 'registerNewMask':
		    $mm = new MaskManagerClass($this->settings);
		    $a = $post["maskElementsJson"];
		    //print_r(json_decode($a));
		    $mm->saveMask(json_decode($post["maskElementsJson"]));
		    $this->ack = $mm->getAck();
		break;
		case 'getListOfVGroups':
		    $mm = new MaskManagerClass($this->settings);
		    $mm->getListOfMasks();
		    $this->ack = $mm->getAck();
		break;
		case 'removeMasks':
		    $mm = new MaskManagerClass($this->settings);
		    $mm->removeMasks(json_decode($post["maskElementsJson"]));
		    $this->ack = $mm->getAck();
		break;
		case 'getVGroupInfo':
		    $mm = new MaskManagerClass($this->settings);
		    $mm->getVGroupInfo($post["VGroupIdForEdit"]);
		    $this->ack = $mm->getAck();
		break;
		case 'getListOfAxis':
		    $am = new AxisManagerClass($this->settings);
		    $am->getAxisOfUserAsJson();
		    $this->ack = $am->getAck();
		break;
		case 'updateAxisList':
		    $am = new AxisManagerClass($this->settings);
		    $am->updateAxis($post["axisElementsJson"]);
		    $am->getAxisOfUserAsJson();
		    $this->ack = $am->getAck();
		break;
		case 'newUserRegistration':
		    $um = new UserManagerClass($this->settings);
		    $um->registerNewUser($post);
		    $this->ack = $um->getAck();
		break;
		case 'loginValidation':
		    $um = new UserManagerClass($this->settings);
		    $um->loginPasswordValidation($post["Login"], $post["Password"]);
		    $this->ack = $um->getAck();
		break;
		case 'getInitialJson':
		    $this->generateInitialJson();
		break;
// TEST PART
		case 'testVGReader':
		    $vgr = new VGReader($props);
		    switch(3){
			case 0:
			    print_r($vgr->GetItemList($grp, $mask, $flags));
			break;
			case 1:
			    print_r($vgr->GetGroupInfo());
			break;
			case 2:
			    print_r($vgr->getMaskStructureAsArray("testMask01", "0"));
			break;
			case 3:
			    echo "Get Database List Test:<BR>\n";
			    print_r($vgr->GetDatabaseList());
			break;
		    }
// TEST PART END
		break;
	    }
	}catch(ADEIException $ex){
	    $ex->logInfo(NULL, $reader?$reader:$req);
	    $error = xml_escape($ex->getInfo());
	    echo $error;
	}
    }
    function generateInitialJson(){
	$mm = new MaskManagerClass($this->settings);
	$am = new AxisManagerClass($this->settings);
	$initArray = array(
	    "Masks" => $mm->getListOfMasksAsArray(),
	    "Axis" => $am->getAxisOfUserAsArray()
	);
	$this->ack = json_encode($initArray);
    }
    function getAck(){
	return $this->ack;
    }
}
?>