<?php
class MaskManagerClass{
 var $settings;
 var $ack;
 var $db;
 var $tempValues;
 var $manageTables;

 function MaskManagerClass($settingsObj){
    $this->settings = $settingsObj;
    $this->db = new userManagerDatabaseClass($this->settings->Databases);
    $this->manageTables = new manageTablesClass($this->db);
    $this->manageTables->checkAndCreateTablesFromXmlObj($this->settings->MasksModule->DatabaseTables);
    $this->tempValues["UserID"] = 0;
 }
 function getListOfMasks(){
    $sql = "SELECT ".
	"`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID."`, ".
	"`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupName."`, ".
	"`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->DateOfCreation."`, ".
	"`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->NumberOfElements."`, ".
	"`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->NumberOfGroups."` ".
	"FROM ".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Name.
	" WHERE ".
	    "`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->UserID."` = \"".$this->tempValues["UserID"]."\"".
    ";";
    
    //echo $this->db->getError();
    //echo $sql;

    $jSON = '({"total": "'.$this->getNumberOfUserMasks().'", "results":[';
    $jSONRaws = array();
    $this->db->sql_query($sql);
    while($raw = mysql_fetch_assoc($this->db->mysql["query_result"])){
	array_push($jSONRaws, '{'.
	    '"VGroupID": "'.$raw[(String) $this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID].'",'.
	    '"VGroupName": "'.$raw[(String) $this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupName].'",'.
	    '"NumberOfElements": "'.$raw[(String) $this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->NumberOfElements].'",'.
	    '"NumberOfGroups": "'.$raw[(String) $this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->NumberOfGroups].'",'.
	    '"BirthDate": "'.$raw[(String) $this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->DateOfCreation].'"'.
	'}');
    }
    $jSON .= implode(",", $jSONRaws).']})';
    $this->ack = $jSON;
 }
 function getListOfMasksAsArray(){
    $sql = "SELECT ".
	"`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID."`, ".
	"`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupName."`, ".
	"`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->DateOfCreation."`, ".
	"`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->NumberOfElements."`, ".
	"`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->NumberOfGroups."` ".
	"FROM ".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Name.
	" WHERE ".
	    "`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->UserID."` = \"".$this->tempValues["UserID"]."\"".
    ";";
    $retArray = array(
	"total" => $this->getNumberOfUserMasks(),
	"results" => array()
    );
    $this->db->sql_query($sql);
    while($raw = mysql_fetch_assoc($this->db->mysql["query_result"])){
	array_push(
	    $retArray["results"],
	    array(
		"MaskName" => $raw[(String) $this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID],
		"MaskDescription" => $raw[(String) $this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupName],
		"NumberOfElements" => $raw[(String) $this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->NumberOfElements],
		"NumberOfGroups" => $raw[(String) $this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->NumberOfGroups],
		"BirthDate" => $raw[(String) $this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->DateOfCreation]
	    )
	);
    }
    return $retArray;
 }
 function removeMasks($jsonObj){
    $IDsArray = array();
    if(is_array($jsonObj->vGroupId)){
	foreach($jsonObj->vGroupId as $ID){
	    array_push($IDsArray, '"'.$ID.'"');
	}
	$setOfIDs = implode(",", $IDsArray);
    }else{
	$setOfIDs = '"'.((string) $jsonObj->vGroupId).'"';
    }
    $sql = "DELETE FROM ".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Name." WHERE ".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID." IN (".$setOfIDs.")";
    $this->db->sql_query($sql);
    //echo $this->db->getError();
    $sql = "DELETE FROM ".$this->settings->MasksModule->DatabaseTables->VgElements->Name." WHERE ".$this->settings->MasksModule->DatabaseTables->VgElements->Columns->VGroupID." IN (".$setOfIDs.")";
    //echo $sql;
    $this->db->sql_query($sql);
    //echo $this->db->getError();
    $jsonArray = array(
	"Type" => "OK", 
	"Message" => "Masks removed successfuly"
    );
    $this->ack = json_encode($jsonArray);
 }
 function saveMask($jsonObj){
    switch($jsonObj->saveType){
	case "Save":
	    if($this->maskExists($jsonObj->vGroupId)){
		$jsonArray = array(
		    "Type" => "Error", 
		    "Message" => "Masks already exists",
		    "Code" => "Exists"
		);
		$this->ack = json_encode($jsonArray);
	    }else{
		$this->ack = json_encode($this->saveNewMask($jsonObj));
	    }
	    break;
	    case "Update":
		$this->ack = json_encode($this->updateMask($jsonObj));
	    break;
    }
    return;
 }
 function saveNewMask($jsonObj){
    $IDs = $jsonObj->IDs;
    $perPostfixArray = array();
    $numberOfElements = 0;
    $numberOfGroups = 0;
    foreach($IDs as $oneElement){
	$oneElementArray = $this->splitPath($oneElement);
	$postfix = $oneElementArray["dBServerName"]."__".$oneElementArray["dBName"]."__".$oneElementArray["dBGroupName"];
	if(!is_array($perPostfixArray[$postfix]["IDs"])){
	    $perPostfixArray[$postfix]["IDs"] = array();
	    $perPostfixArray[$postfix]["Axis"] = array();
	    $numberOfGroups++;
	}
	array_push($perPostfixArray[$postfix]["IDs"], $oneElementArray["element"]);
	array_push($perPostfixArray[$postfix]["Axis"], $jsonObj->Axis[$numberOfElements]);
	$numberOfElements++;
    }
    $sql = "INSERT INTO ".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Name." (".
	 "`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->UserID."`, ".
	 "`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID."`, ".
	 "`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupName."`,".
	 "`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->NumberOfElements."`,".
	 "`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->NumberOfGroups."`".
	") VALUES (".
	 $this->tempValues["UserID"].", ".
	 "\"".$jsonObj->vGroupId."\", ".
	 "\"".$jsonObj->vGroupName."\",".
	 $numberOfElements.",".
	 $numberOfGroups.
    ");";
    $this->db->sql_query($sql);
    //echo $sql;
//    $this->db->getError();
    while (list($postfix, $arrayOfElements) = each($perPostfixArray)){
	    $sql = "INSERT INTO ".$this->settings->MasksModule->DatabaseTables->VgElements->Name." (".
		"`".$this->settings->MasksModule->DatabaseTables->VgElements->Columns->VGroupID."`,".
		"`".$this->settings->MasksModule->DatabaseTables->VgElements->Columns->Postfix."`,".
		"`".$this->settings->MasksModule->DatabaseTables->VgElements->Columns->ItemIDs."`,".
		"`".$this->settings->MasksModule->DatabaseTables->VgElements->Columns->ItemAxis."`".
	    ") VALUES (".
		"\"".$jsonObj->vGroupId."\", ".
		"\"".$postfix."\", ".
		"\"".implode(",", $arrayOfElements["IDs"])."\", ".
		"\"".implode(",", $arrayOfElements["Axis"])."\"".
	    ");";
	    $this->db->sql_query($sql);
    }
    //echo $sql;
    echo $this->db->getError();
    //$this->ack = implode(",", $allValues);
    //array_push($allValues, "(".implode(",", array_reverse($items)).")");
    $jsonArray = array(
	"Type" => "OK", 
	"Message" => "Mask Saved Successfully"
    );
    return $jsonArray;

 }
 function updateMask($jsonObj){
    $this->removeMasks($jsonObj);
    $this->saveNewMask($jsonObj);
    $jsonArray = array(
	"Type" => "OK", 
	"Message" => "Mask Updated Successfully"
    );
    return $jsonArray;
 }

 function maskExists($vGroupId){
    $sql = "SELECT COUNT(*) AS count FROM ".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Name." WHERE `".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID."` = \"".$vGroupId."\";";
    $this->db->sql_getRows($sql);
    $result = mysql_fetch_assoc($this->db->mysql["query_result"]);
    if($result["count"] > 0){
	return true;
    }else{
	return false;
    }
 }
 function getNumberOfUserMasks(){
    $sql = "SELECT COUNT(*) AS count FROM ".
	$this->settings->MasksModule->DatabaseTables->vGroupsTable->Name.
	" WHERE ".
	"`".$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->UserID."` = \"".$this->tempValues["UserID"]."\"";
    $this->db->sql_query($sql);
    $result = mysql_fetch_assoc($this->db->mysql["query_result"]);
    $count = $result["count"];
    $this->db->sql_free_result();
    return $count;
 }
 function getVGroupInfo($id){
    $retJson = array(
	"IDs" => array(),
	"AxisIds" => array(),
	"vGroupId" => $id,
	"vGroupName" => "testMask"
    );
    $masksTableName = $this->settings->MasksModule->DatabaseTables->vGroupsTable->Name;
    $vGroupElementsTableName = $this->settings->MasksModule->DatabaseTables->VgElements->Name;
    $vgElementsTableName = $this->settings->MasksModule->DatabaseTables->VgElements->Name;
    $sql = 'select 
		'.$vgElementsTableName.'.'.$this->settings->MasksModule->DatabaseTables->VgElements->Columns->Postfix.' as postfix,
		'.$vgElementsTableName.'.'.$this->settings->MasksModule->DatabaseTables->VgElements->Columns->ItemIDs.' as itemIds,
		'.$vgElementsTableName.'.'.$this->settings->MasksModule->DatabaseTables->VgElements->Columns->ItemAxis.' as axisIds,
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID.' as maskID,
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupName.' as maskName
	    FROM 
		'.$vgElementsTableName.', '.$masksTableName.'
	    WHERE
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID.' = '.$vGroupElementsTableName.'.'.$this->settings->MasksModule->DatabaseTables->VgElements->Columns->VGroupID.' and 
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID.' = "'.$id.'";';
    //echo $sql;
    $this->db->sql_query($sql);
    while($raw = mysql_fetch_assoc($this->db->mysql["query_result"])){
	$itemIds = split(",", $raw['itemIds']);
	foreach($itemIds as $id){
	    $postfix = $raw['postfix'];
	    $postfixArray = split('__', $postfix);
	    $postfix = implode("^", $postfixArray);
	    $id = trim($id);
	    array_push($retJson['IDs'], "servers^".$postfix."^".$id);
	}
	$axisIds = split(",", $raw['axisIds']);
	foreach($axisIds as $id){
	    $id = trim($id);
	    array_push($retJson['AxisIds'], $id);
	}
	$retJson['vGroupName'] = $raw['maskName'];
    }
    $this->ack = json_encode($retJson);
    //$this->ack = '{"IDs":["servers^toska^womisaDB_repl^m02^0","servers^toska^womisaDB_repl^m02^1","servers^toska^womisaDB_repl^m02^11"],"vGroupName":"testMask","vGroupNotes":"testMask"}';
    return true;
 }
 function getMaskStructureAsArray($maskName, $userId){
    $masksTableName = $this->settings->MasksModule->DatabaseTables->vGroupsTable->Name;
    $vgElementsTableName = $this->settings->MasksModule->DatabaseTables->VgElements->Name;
    $sql = 'SELECT
		'.$vgElementsTableName.'.'.$this->settings->MasksModule->DatabaseTables->VgElements->Columns->Postfix.' as postfix,
		'.$vgElementsTableName.'.'.$this->settings->MasksModule->DatabaseTables->VgElements->Columns->ItemIDs.' as itemIds,
		'.$vgElementsTableName.'.'.$this->settings->MasksModule->DatabaseTables->VgElements->Columns->ItemAxis.' as axisIds,
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupName.' as vGroupName,
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID.' as vGroupId
	    FROM 
		'.$vgElementsTableName.', '.$masksTableName.'
	    WHERE
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID.' = vgElements.'.$this->settings->MasksModule->DatabaseTables->VgElements->Columns->VGroupID.' and 
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->UserID.' = "'.$userId.'" and 
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupName.' = "'.$maskName.'";';
    $this->db->sql_query($sql);
    //echo $sql;
    //echo $this->db->getError();
    $retArray = array();
    $retArray["maskId"] = $maskName;
    $retArray["userId"] = $userId;
    while($raw = mysql_fetch_assoc($this->db->mysql["query_result"])){
	$postfix = $raw["postfix"];
	$itemIds = $raw["itemIds"];
	$axisIds = $raw["axisIds"];
	$retArray["postfixes"][$postfix]["pathArray"] = split("__", $postfix);
	$retArray["postfixes"][$postfix]["path"] = $postfix;
	$retArray["postfixes"][$postfix]["itemIds"] = split(",", $itemIds);
	$retArray["postfixes"][$postfix]["axisIds"] = split(",", $axisIds);
	$retArray["vGroupName"] = $raw["vGroupName"];
	$retArray["vGroupId"] = $raw["vGroupId"];
    }
    return $retArray;
 }
 function getListOfUserMasks($userId){
    $this->settings->MasksModule->DatabaseTables->vGroupsTable->Name;
    $sql = 'select 
		'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupName.' as vGroupName
	    FROM 
		'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Name.'
	    WHERE
		'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->UserID.' = "'.$userId.'";';
    $this->db->sql_query($sql);
    $retArray = array();
    while($raw = mysql_fetch_assoc($this->db->mysql["query_result"])){
	array_push($retArray, $raw["vGroupName"]);
    }
    return $retArray;
 }
 function getMaskGroupsAndElementsIDs($maskId){
    $masksTableName = $this->settings->MasksModule->DatabaseTables->vGroupsTable->Name;
    $vgElementsTableName = $this->settings->MasksModule->DatabaseTables->VgElements->Name;
    $sql = 'select 
		'.$vgElementsTableName.'.'.$this->settings->MasksModule->DatabaseTables->VgElements->Columns->Postfix.' as postfix,
		'.$vgElementsTableName.'.'.$this->settings->MasksModule->DatabaseTables->VgElements->Columns->ItemIDs.' as itemIds,
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupName.' as maskDescription
	    FROM 
		'.$vgElementsTableName.', '.$masksTableName.'
	    WHERE
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID.' = vgElements.title and 
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID.' = "'.$id.'";';
    $this->db->sql_query($sql);
    while($raw = mysql_fetch_assoc($this->db->mysql["query_result"])){
	$itemIds = split(",", $raw['itemIds']);
	foreach($itemIds as $id){
	    $postfix = $raw['postfix'];
	    $postfixArray = split('__', $postfix);
	    $postfix = implode("^", $postfixArray);
	    $id = trim($id);
	    array_push($retJson['IDs'], "servers^".$postfix."^".$id);
	}
	$retJson['vGroupNotes'] = $raw['maskDescription'];
    }
    $this->ack = json_encode($retJson);
    //$this->ack = '{"IDs":["servers^toska^womisaDB_repl^m02^0","servers^toska^womisaDB_repl^m02^1","servers^toska^womisaDB_repl^m02^11"],"vGroupName":"testMask","vGroupNotes":"testMask"}';
    return true;

 }
 function getArrayOfUsedAxis(){
    $sql = 'select 
		'.$vgElementsTableName.'.'.$this->settings->MasksModule->DatabaseTables->VgElements->Columns->Postfix.' as postfix,
		'.$vgElementsTableName.'.'.$this->settings->MasksModule->DatabaseTables->VgElements->Columns->ItemIDs.' as itemIds,
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupName.' as maskDescription
	    FROM 
		'.$vgElementsTableName.', '.$masksTableName.'
	    WHERE
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID.' = vgElements.title and 
		'.$masksTableName.'.'.$this->settings->MasksModule->DatabaseTables->vGroupsTable->Columns->VGroupID.' = "'.$id.'";';

 }
 function splitPath($path){
    $ret = array();
    $pathArray = split("\^", $path);
    $size = sizeof($path);
    $ret["fullPath"] = $path;
    $ret["element"] = $pathArray[4];
    $ret["dBGroupName"] = $pathArray[3];
    $ret["dBName"] = $pathArray[2];
    $ret["dBServerName"] = $pathArray[1];
    array_multisort($ret);
    return $ret;
 }
 function getAck(){
    return $this->ack;
 }
}
?>