Ext.BLANK_IMAGE_URL = '../includes/ext/resources/images/default/s.gif';
var serverPhpUrl = "../services/ui_server.php";

Ext.onReady(function(){
var loginForm = new Ext.FormPanel({
    url: serverPhpUrl + '?target=loginValidation',
    defaultType:'textfield',
    width: 500,
    height: 120,
    region: 'north',
    frame: true,
    items: [
            {
                fieldLabel: 'Login',
                name: 'Login',
                width:250,
                allowBlank:false
            }, {
                fieldLabel: 'Password',
                name: 'Password',
                width:250,
                allowBlank:false
            }
    ],
    buttons:[{
            text:'Login',
            formBind: true,
            // Function that fires when user clicks the button
            handler:function(){
		    loginForm.getForm().submit({
                    method:'POST',
                    waitTitle:'Connecting',
                    waitMsg:'Sending data...',
                    success:function(){
			window.location = "userArea.html";
		    },
		    failure:function(form, action){
			if(action.failureType == 'server'){
			    obj = Ext.util.JSON.decode(action.response.responseText);
			    Ext.Msg.alert('Submit Failed!', obj.errors.reason);
			}else{
			    Ext.Msg.alert('Warning!', 'Authentication server is unreachable : ' + action.response.responseText + "abcd");
			}
		    }
                });
            }
        }
    ]

});
var registrationForm = new Ext.FormPanel({
    title: 'Registration',
    width: 500,
    height: 500,
    labelWidth: 200,
    url: serverPhpUrl + '?target=newUserRegistration',
    frame:true,
    defaultType:'textfield',
    monitorValid:true,
    items: [
            {
                fieldLabel: 'First Name',
                name: 'First Name',
                width:250,
                allowBlank:false
            }, {
                fieldLabel: 'Last Name',
                name: 'SurName',
                width:250,
                allowBlank:false
            }, {
                fieldLabel: 'Institution',
                name: 'Institution',
                width:250,
                allowBlank:false
            }, {
                fieldLabel: 'Affiliation',
                name: 'Affiliation',
                width:250,
                allowBlank:false
            }, {
                fieldLabel: 'Address1',
                name: 'Address1',
                width:250,
                allowBlank:false
            }, {
                fieldLabel: 'Address2',
                name: 'Address2',
                width:250
            }, {
                fieldLabel: 'City',
                name: 'City',
                width:250
            }, {
                fieldLabel: 'State/Province',
                name: 'StateProvince',
                width:250
            }, {
                fieldLabel: 'Zip/Post',
                name: 'ZipPost',
                width:250
            }, {
                fieldLabel: 'Phone',
                name: 'Phone',
                width:250
            }, {
                fieldLabel: 'Fax',
                name: 'Fax',
                width:250
            }, {
                fieldLabel: 'E-Mail',
                name: 'EMail',
                width:250,
                vtype: 'email'
            },
            new Ext.form.ComboBox({
                fieldLabel: 'Country',
                name:'Country',
                store: new Ext.data.SimpleStore({
                    fields: ['abbr', 'Country'],
                    data : Ext.data.countries // from countries.js
                }),
                valueField:'abbr',
                displayField:'Country',
                typeAhead: true,
                mode: 'local',
                triggerAction: 'all',
                emptyText:'Select country...',
                selectOnFocus:true,
                width:250,
                allowBlank:false
            }),{
                fieldLabel: 'Login',
                name: 'LoginName',
                width:250,
                allowBlank: false
            }, {
                fieldLabel: 'Password',
                name: 'Password1',
                width:250,
                inputType: 'Password',
                allowBlank: false
            }, {
                fieldLabel: 'Confirm Password',
                name: 'Confirm_Password',
                width:250,
                inputType: 'Password',
                allowBlank: false
            }
    ],
    buttons:[{
            text:'Submit',
            formBind: true,
            // Function that fires when user clicks the button
            handler:function(){
                registrationForm.getForm().submit({
                    method:'POST',
                    waitTitle:'Connecting',
                    waitMsg:'Sending data...',
		    success: function(){
			Ext.Msg.alert('Status', 'Submit Successful!', function(btn, text){
			    if (btn == 'ok'){
				loginForm.form.findField('Login').setValue(registrationForm.form.findField('LoginName').getValue());
				loginForm.form.findField('Password').setValue(registrationForm.form.findField('Password1').getValue());
			    }
			});
		    },
		    failure: function(form, action){
			obj = Ext.util.JSON.decode(action.response.responseText);
			Ext.Msg.alert('Submit Failed: ', obj.error.reason);
		    }
		});
	    }
	}]
 });
 var newsPanel = new Ext.Panel({
    title: "News",
    frame: true,
    autoLoad: "./information.html",
 });
 var loginAcordionPanel = new Ext.Panel({
    width: 500,
    height: 500,
    region: 'center',
    layout: 'accordion',
    items:[
	newsPanel,
	registrationForm
    ]
 });
 var registrationPanel = new Ext.Panel({
    title: 'Main',
    renderTo: 'loginContainer',
    layout:'border',
    height: 700,
    width: 500,
    items: [
	loginForm,
	loginAcordionPanel
    ]
 });

})
