/*
 * ================  AccordionLayout config  =======================
 */
    getInitialJson();
    var myData = [];
    var axisAssociativeArray = [];
    function getInitialJson(){
	Ext.Ajax.request({
	    url : serverPhpUrl + '&target=getInitialJson',
	    method: 'POST',
	    timeout: 60000,
	    success: function ( result, request ) {
		initialJsonObj = Ext.util.JSON.decode(result.responseText);
		myData = [];
		availableAxis = [];
		for(i=0; i<initialJsonObj.Axis.length; i++){
		    id = initialJsonObj.Axis[i].ID;
		    myData[id] = [
			id,
			initialJsonObj.Axis[i].Name,
			initialJsonObj.Axis[i].Unit,
			initialJsonObj.Axis[i].Log,
			initialJsonObj.Axis[i].RangeBegin,
			initialJsonObj.Axis[i].RangeEnd
		    ];
		    availableAxis[i] = [
			initialJsonObj.Axis[i].Name,
			id
		    ];
		    axisAssociativeArray[initialJsonObj.Axis[i].Name] = id;
		}
		ds.loadData(myData);
		gridAxisEditorStore.loadData(availableAxis);
	    },
	    failure: function ( result, request) {
		Ext.MessageBox.alert('Failed', result.responseText);
	    }
	});

    }
    var ds = new Ext.data.Store({
        reader: new Ext.data.ArrayReader({}, [
               {name: 'ID', type: 'int'},
               {name: 'AxisName', type: 'string'},
               {name: 'Unit', type: 'string'},
               {name: 'Log', type: 'boolean'},
               {name: 'RangeBegin', type: 'float'},
               {name: 'RangeEnd', type: 'float'}
          ])
    });


    // example of custom renderer function
    function italic(value){
        return '' + value + '';
    }

    // example of custom renderer function
    function Log(val){
        if(val > 0){
            return 'Log';
        }else{
            return '';
        }
        return val;
    }

    // the DefaultColumnModel expects this blob to define columns. It can be extended to provide
    // custom or reusable ColumnModels
    var colModel = new Ext.grid.ColumnModel([
        {id: 'ID',header: "ID", width: 20, sortable: true, locked:false, dataIndex: 'ID'},
        {id: 'AxisName',header: "AxisName", width: 200, sortable: true, locked:false, dataIndex: 'AxisName'},
        {id: 'Unit', header: "Unit", width: 50, sortable: true, dataIndex: 'Unit'},
        {id: 'Log', header: "Log", width: 75, sortable: true, renderer: Log, dataIndex: 'Log'},
        {id: 'RangeBegin',header: "RangeBegin", width: 100, sortable: true, locked:false, dataIndex: 'RangeBegin'},
        {id: 'RangeEnd',header: "RangeEnd", width: 100, sortable: true, locked:false, dataIndex: 'RangeEnd'}
    ]);

    //bd.createChild({tag: 'h2', html: 'Using a Grid with a Form'});

/*
 *	Here is where we create the Form
 */
    var gridForm = new Ext.FormPanel({
        id: 'AxisName-form',
        frame: true,
        labelAlign: 'left',
        title: 'Edit',
        bodyStyle:'padding:5px',
        width: 900,
        layout: 'column',
        items: [{
            columnWidth: 0.6,
            layout: 'fit',
            items: {
		id: 'AxisGrid',
                xtype: 'grid',
                ds: ds,
                cm: colModel,
                sm: new Ext.grid.RowSelectionModel({
		    id: 'axisGridSelectionModel',
                    singleSelect: true,
                    listeners: {
                        rowselect: function(sm, row, rec) {
			    Ext.getCmp("AxisName-form").form.findField('AxisName').setValue(rec.get("AxisName"));
			    Ext.getCmp("AxisName-form").form.findField('Unit').setValue(rec.get("Unit"));
			    Ext.getCmp("AxisName-form").form.findField('Log').setValue(rec.get("Log"));
			    Ext.getCmp("AxisName-form").form.findField('ID').setValue(rec.get("ID"));
			    Ext.getCmp("AxisName-form").form.findField('RangeBegin').setValue(rec.get("RangeBegin"));
			    Ext.getCmp("AxisName-form").form.findField('RangeEnd').setValue(rec.get("RangeEnd"));
			}
		    }
                }),
                autoExpandColumn: 'AxisName',
                height: 400,
		width: 500,
                title:'Available Axis',
                border: true,
		frame: true,
	        listeners: {
	    	render: function(g) {
	    	    g.getSelectionModel().selectRow(0);
	    	},
	    	delay: 10 // Allow rows to be rendered.
	        },
		tbar: [
		    {
			text: 'Remove',
			iconCls: 'remove',
			handler: function(){
			    selectedAxis = Ext.getCmp("AxisGrid").selModel.getSelections();
			    newAxisArray = new Array();
			    for(i=0; i<myData.length; i++){
				selectedId = selectedAxis[0].get('ID');
				if(i != selectedId){
				    oneRow = myData[i];
				    oneRow[0] = newAxisArray.length;
				    newAxisArray.push(oneRow);
				}
			    }
			    myData = newAxisArray;
			    ds.loadData(myData);
			    if(selectedId >= myData.length){
				Ext.getCmp("AxisGrid").getSelectionModel().selectLastRow();
			    }else{
				Ext.getCmp("AxisGrid").getSelectionModel().selectRow(selectedId);
			    }
			    //alert('remove: ' + selectedAxis[0].get('ID'));
			}
		    },{
			text: 'New',
			iconCls: 'new',
			handler: function(){
			    myData.push([myData.length, '', '', false]);
			    ds.loadData(myData);
			    Ext.getCmp("AxisName-form").form.findField('AxisName').setValue('');
			    Ext.getCmp("AxisName-form").form.findField('Unit').setValue('');
			    Ext.getCmp("AxisName-form").form.findField('Log').setValue(false);
			    Ext.getCmp("AxisName-form").form.findField('RangeBegin').setValue("");
			    Ext.getCmp("AxisName-form").form.findField('RangeEnd').setValue("");
			    Ext.getCmp("AxisGrid").getSelectionModel().selectRow(myData.length - 1);
			}
		    },{
			text: 'Save',
			iconCls: 'save',
			handler: function(){
			    corruptedIdsArray = new Array();
			    json = {
				"Axis": []
			    };
			    for(i=0; i<myData.length; i++){
				for(j=1; j<myData[i].length - 2; j++){
				    if(myData[i][j].length == 0){
					corruptedIdsArray.push(i);
					break;
				    }
				}
				oneRow = {
				    "ID": i,
				    "Name": myData[i][1],
				    "Unit": myData[i][2],
				    "Log": myData[i][3],
				    "Color": "#ff0011",
				    "RangeBegin": myData[i][4],
				    "RangeEnd": myData[i][5]
				}
				json.Axis[i] = oneRow;
			    }
			    if(corruptedIdsArray.length != 0){
				message = "Axis with IDs: " + corruptedIdsArray.join(", ") + " have empty fields. Please fill them or remove before save.";
				Ext.MessageBox.alert('Failed', message);
			    }else{
				encodedJson = Ext.util.JSON.encode(json);
				Ext.Ajax.request({
				    url : serverPhpUrl + '&target=updateAxisList',
				    params : {
					"axisElementsJson": encodedJson
				    },
				    method: 'POST',
				    timeout: 60000,
				    success: function ( result, request ) {
					jsonAckObj = Ext.util.JSON.decode(result.responseText);
					myData = [];
					availableAxis = [];
					for(i=0; i<jsonAckObj.Axis.length; i++){
					    id = jsonAckObj.Axis[i].ID;
					    myData[id] = [
						id,
						jsonAckObj.Axis[i].Name,
						jsonAckObj.Axis[i].Unit,
						jsonAckObj.Axis[i].Log,
						jsonAckObj.Axis[i].Color
					    ];
					    availableAxis[i] = [
						jsonAckObj.Axis[i].Name,
						id
					    ]
					}
					ds.loadData(myData);
					gridAxisEditorStore.loadData(availableAxis);
				    },
				    failure: function ( result, request) {
					Ext.MessageBox.alert('Failed', result.responseText);
				    }
				});

			    }
			}
		    }
		]
	    }
	},{
	    columnWidth: 0.4,
	    xtype: 'fieldset',
	    labelWidth: 50,
	    title:'Edit axis',
	    defaults: {width: 140},	// Default config options for child items
	    defaultType: 'textfield',
	    autoHeight: true,
	    bodyStyle: Ext.isIE ? 'padding:0 0 5px 15px;' : 'padding:10px 15px;',
	    border: true,
	    frame: true,
	    tbar: [
		{
		    text: 'update',
		    iconCls: 'edit',
		    handler: function(){
			iD = Ext.getCmp("AxisName-form").form.findField('ID').getValue()
			newRow = [
			    iD,
			    Ext.getCmp("AxisName-form").form.findField('AxisName').getValue(),
			    Ext.getCmp("AxisName-form").form.findField('Unit').getValue(),
			    Ext.getCmp("AxisName-form").form.findField('Log').getValue(),
			    Ext.getCmp("AxisName-form").form.findField('RangeBegin').getValue(),
			    Ext.getCmp("AxisName-form").form.findField('RangeEnd').getValue()
			];
			myData[iD] = newRow;
			ds.loadData(myData);
			Ext.getCmp("AxisGrid").getSelectionModel().selectRow(iD);
		    }
		}
	    ],
	    style: {
		"margin-left": "10px", // when you add custom margin in IE 6...
		"margin-right": Ext.isIE6 ? (Ext.isStrict ? "-10px" : "-13px") : "0"  // you have to adjust for it somewhere else
	    },
	    items: [{
		fieldLabel: 'Name',
		name: 'AxisName'
	    },{
		fieldLabel: 'Unit',
		name: 'Unit'
	    },{
		xtype:'fieldset',
		title: 'Range',
		collapsible: true,
		autoHeight:true,
		defaultType: 'textfield',
		labelWidth: 40,
		width: 200,
		items :[
		    {
			fieldLabel: 'Begin',
			width: 130,
			name: 'RangeBegin',
			xtype: 'numberfield'
		    },{
			fieldLabel: 'End',
			width: 130,
			name: 'RangeEnd',
			xtype: 'numberfield'
		    }
		]
	    },{
		id: 'Log',
		xtype:'checkbox',
		fieldLabel: 'Log',
		name: 'Log',
		allowBlank:false
	    },{
		name:'ID',
		type:'hidden',
		hidden:true
	    }]
        }]
    });
    var createNewAxisPanel = {
	id: 'createNewAxis-panel',
	//width: 620,
	height: 600,
	border: false,
	frame: true,
	items: [
	    gridForm
	]
    };
